# Generated by Django 5.0.6 on 2024-05-22 14:29

import django.db.models.deletion
from django.db import migrations, models
from django.conf import settings


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
    ]

    configurations = getattr(settings, 'GLOBAL_PLACES', {})
    if configurations.get('INCLUDE_LOCATION', False):
        fields = [
                    (
                        "id",
                        models.BigAutoField(
                            auto_created=True,
                            primary_key=True,
                            serialize=False,
                            verbose_name="ID",
                        ),
                    ),
                    ("name", models.CharField(max_length=100, unique=True)),
                    ("iso3", models.CharField(max_length=3)),
                    ("latitude", models.FloatField()),
                    ("longitude", models.FloatField()),
                    ("is_active", models.BooleanField(default=True)),
                ]

        if configurations.get('INCLUDE_EXPANDED_COUNTRY', False):
            fields += [
                ("iso2", models.CharField(blank=True, max_length=2, null=True)),
                ("numeric_code", models.CharField(blank=True, max_length=3, null=True)),
                ("phone_code", models.CharField(blank=True, max_length=3, null=True)),
                ("currency", models.CharField(blank=True, max_length=3, null=True)),
                (
                    "currency_name",
                    models.CharField(blank=True, max_length=100, null=True),
                ),
                (
                    "currency_symbol",
                    models.CharField(blank=True, max_length=3, null=True),
                ),
            ]

        operations.append(
            migrations.CreateModel(
                name="Country",
                fields=fields,
                options={
                    "verbose_name_plural": "Countries",
                },
            ),
        )
        if not configurations.get('LOCATION_SCOPE', None) == 'country':
            operations.append(
            migrations.CreateModel(
                name="State",
                fields=[
                    (
                        "id",
                        models.BigAutoField(
                            auto_created=True,
                            primary_key=True,
                            serialize=False,
                            verbose_name="ID",
                        ),
                    ),
                    ("json_id", models.IntegerField()),
                    ("name", models.CharField(max_length=100)),
                    ("state_code", models.CharField(max_length=5)),
                    ("latitude", models.FloatField(blank=True, null=True)),
                    ("longitude", models.FloatField(blank=True, null=True)),
                    ("is_active", models.BooleanField(default=True)),
                    (
                        "country",
                        models.ForeignKey(
                            on_delete=django.db.models.deletion.CASCADE,
                            related_name="states",
                            to="django_global_places.country",
                        ),
                    ),
                ],
                options={
                    "verbose_name_plural": "States",
                },
            ),
        )
            if configurations.get('LOCATION_SCOPE', None) == 'city':
                operations.append(
                    migrations.CreateModel(
                        name="City",
                        fields=[
                            (
                                "id",
                                models.BigAutoField(
                                    auto_created=True,
                                    primary_key=True,
                                    serialize=False,
                                    verbose_name="ID",
                                ),
                            ),
                            ("json_id", models.IntegerField()),
                            ("name", models.CharField(max_length=100)),
                            ("latitude", models.FloatField(blank=True, null=True)),
                            ("longitude", models.FloatField(blank=True, null=True)),
                            ("is_active", models.BooleanField(default=True)),
                            (
                                "state",
                                models.ForeignKey(
                                    on_delete=django.db.models.deletion.CASCADE,
                                    related_name="cities",
                                    to="django_global_places.state",
                                ),
                            ),
                        ],
                        options={
                            "verbose_name_plural": "Cities",
                        },
                    ),
                )